#include <msp430g2553.h>
#define LED_DRAW(x,y) tab[y]|=seg[x+1]
#define LED_WIPE(x,y) tab[y]&=~seg[x+1]
#define SYS_DELAY() __delay_cycles(700)
#define KEY_DELAY() __delay_cycles(20000)
#define SYS_WORK(void) main(void)
#define LIGHT_ON (ADC10MEM>23)
#define STOP_TIME (tap*2350)
unsigned int tab[16]={0},tab0[4][16]={0},seg[17]={0},count=0;
char body[50][2]={6,7,7,7,8,7},food[4]={5,5},length=3,key=4,mode=0,tap=1,pause=0;
void SYS_START(void){
	char mm=2;
	WDTCTL=WDTPW|WDTHOLD;
	for(seg[1]=1;mm<17;mm++)seg[mm]=seg[mm-1]*2;
	P2DIR|=BIT0+BIT1+BIT2+BIT3+BIT4+BIT5;
	P1REN|=BIT3+BIT4+BIT5+BIT6+BIT7;
	P1OUT|=BIT3+BIT4+BIT5+BIT6+BIT7;
	BCSCTL1=CALBC1_16MHZ;
 	DCOCTL=CALDCO_16MHZ;
}
void LED_SEND(char dat){
	char i=0;
	for(i=0;i<8;i++){
		P2OUT&=~BIT4;
		if(dat&0x80)P2OUT|=BIT5;
		else P2OUT&=~BIT5;
		dat<<=1;
		P2OUT|=BIT4;
	}
}
void LED_SET(char dat){
	char i=0;
	for(i=0;i<8;i++){
		P2OUT&=~BIT0;
		if(dat&0x80)P2OUT|=BIT2;
		else P2OUT&=~BIT2;
		dat<<=1;
		P2OUT|=BIT0;
	}
}
void LED_DATA(char dat1,char dat2){
	LED_SET(dat1);
	LED_SET(dat2);
	P2OUT|=BIT1;
	_NOP();
	P2OUT&=~BIT1;
}
void LED_LINE(char a){
	unsigned int t=seg[a+1];
	LED_SEND(t>>8);
	LED_SEND(t);
	P2OUT|=BIT3;
	_NOP();
	P2OUT&=~BIT3;
}
void LED_SHOW(void){
	char j=0,k=0;
	for(j=0;j<16;j++){
		LED_DATA(0xff,0xff);
		LED_LINE(j);
		for(k=0;k<16;k++)LED_DATA(~tab[j]/256,~tab[j]%256);
	}
}
void LED_DISPLAY(char a){
	char j=0,k=0;
	for(j=0;j<16;j++){
		LED_DATA(0xff,0xff);
		LED_LINE(j);
		for(k=0;k<16;k++){
			LED_DATA(~seg[k+1]/256,~seg[k+1]%256);
			LED_DATA(~tab0[a][j]/256,~tab0[a][j]%256);
			SYS_DELAY();
		}
	}
}
void LED_CHECK(char j,char k){
	static char jx=0,kx=0;
	LED_DATA(~seg[k+1]/256,~seg[k+1]%256);
	ADC10CTL0|=ENC+ADC10SC;
	if(LIGHT_ON){
		UCA0TXBUF=j*16+k;
		count=0;
		if((k!=kx)||(j!=jx)){
			if(mode){
				if(j==jx-1){
					for(j=1;j<16;j++)tab[j-1]=tab[j];
					tab[15]=0;
				}
				else if(j==jx+1){
					for(j=0;j<15;j++)tab[15-j]=tab[14-j];
					tab[0]=0;
				}
				if(k==kx+1)for(j=0;j<16;j++)tab[j]=tab[j]<<1;
				else if(k==kx-1)for(j=0;j<16;j++)tab[j]=tab[j]>>1;
			}
			else{
				if((tab[j]&seg[k])!=seg[k])tab[j]|=seg[k];
				else tab[j]&=~seg[k];
			}
			jx=j;
			kx=k;
		}
	}
	LED_DATA(~tab[j]/256,~tab[j]%256);
	SYS_DELAY();
}
void LED_FLASH(void){
	char j=0,k=0;
	for(j=0;j<16;j++){
		LED_DATA(0xff,0xff);
		LED_LINE(j);
		for(k=0;k<16;k++){
			LED_DATA(~seg[k+1]/256,~seg[k+1]%256);
			LED_DATA(~tab[j]/256,~tab[j]%256);
			SYS_DELAY();
		}
	}
}
void LED_PAUSE(void){
	while(pause){
		LED_SHOW();
		if(!(P1IN&BIT3)){
			while(!(P1IN&BIT3))LED_SHOW();
			KEY_DELAY();
			count=0;
			pause=~pause;
		}
	}
}
void LED_KEY(void){
	char j=0;
	if(!(P1IN&BIT3)){
		while(!(P1IN&BIT3))LED_FLASH();
		KEY_DELAY();
		count=0;
		pause=~pause;
	}
	else if(!(P1IN&BIT5)){
		count=0;
		while(!(P1IN&BIT5))LED_FLASH();
		KEY_DELAY();
		mode=~mode;
	}
	else if(!(P1IN&BIT4)){
		count=0;
		while(!(P1IN&BIT4))LED_FLASH();
		KEY_DELAY();
		for(j=0;j<16;j++)tab[j]=~tab[j];
	}
	else if(!(P1IN&BIT6)){
		count=0;
		while(!(P1IN&BIT6))LED_FLASH();
		for(j=0;j<100;j++)LED_DISPLAY(0);
		for(j=0;j<100;j++)LED_DISPLAY(1);
		for(j=0;j<100;j++)LED_DISPLAY(2);
		for(j=0;j<100;j++)LED_DISPLAY(3);
	}
	else if(!(P1IN&BIT7)){
		while(!(P1IN&BIT7))LED_FLASH();
		for(j=0;j<16;j++)tab[j]=0;
	}
}
void LED_CYCLE(void){
	char j=0,k=0;
	if(STOP_TIME==count){
		count=0;
		pause=~pause;
	}
	else count++;
	LED_PAUSE();
	LED_KEY();
	for(j=0;j<16;j++){
		LED_DATA(0xff,0xff);
		LED_LINE(j);
		for(k=0;k<16;k++)LED_CHECK(j,k);
	}
}
void LED_START(void){
	P1SEL=BIT1+BIT2;
	P1SEL2=BIT1+BIT2;
	ADC10CTL0=ADC10SHT_3+ADC10ON;
	ADC10CTL1=ADC10SSEL_2;
	ADC10AE0|=0x01;
 	UCA0CTL1|=UCSSEL_2;
 	UCA0BR0=0x82;
 	UCA0BR1=0x06;
 	UCA0MCTL=UCBRS2+UCBRS1;
 	UCA0CTL1&=~UCSWRST;
 	IE2|=UCA0RXIE;
 	_EINT();
}
void GAM_FOOD(void){
	char i=0;
	unsigned long next=0;
    while(1){
L:   	next=TA0R*TA0R;
        food[2]=(char)next%15;
        next=(TA0R+1)*(TA0R+1);
        food[3]=(char)next%15;
        if(food[2]==0||food[3]==0)goto L;
        for(i=0;i<length;i++)if((food[2]==body[i][0])&&(food[3]==body[i][1]))goto L;
        break;
    }
	food[0]=food[2];
	food[1]=food[3];
	LED_DRAW(food[2],food[3]);
}
void GAM_ROOM(void){
	char mm=0;
	for(mm=0;mm<16;mm++){
		LED_DRAW(mm,0);
		LED_DRAW(mm,15);
		LED_DRAW(0,mm);
		LED_DRAW(15,mm);
	}
}
void GAM_END(void){
	char i=0;
	for(i=0;i<16;i++)tab[i]=seg[i+1]+seg[16-i];
	GAM_ROOM();
	while(1)LED_SHOW();
}
void GAM_STEP(void){
	char i=0;
	if(key==1){
		body[49][1]++;
		if(body[49][1]==15)GAM_END();
	}
	else if(key==2){
		body[49][1]--;
		if(body[49][1]==0)GAM_END();
	}
	else if(key==3){
		body[49][0]--;
		if(body[49][0]==0)GAM_END();
	}
	else{
		body[49][0]++;
		if(body[49][0]==15)GAM_END();
	}
    for(i=0;i<length;i++)if((body[i][0]==body[49][0])&&(body[i][1]==body[49][1]))GAM_END();
	if((body[49][0]==food[0])&&(body[49][1]==food[1])){
		length++;
		body[length-1][0]=body[49][0];
		body[length-1][1]=body[49][1];
		GAM_FOOD();
	}
	else{
		LED_WIPE(body[0][0],body[0][1]);
		for(i=0;i<length-1;i++){
			body[i][0]=body[i+1][0];
			body[i][1]=body[i+1][1];
		}
		body[length-1][0]=body[49][0];
		body[length-1][1]=body[49][1];
		for(i=0;i<length;i++)LED_DRAW(body[i][0],body[i][1]);
	}
}
void GAM_START(void){
	char mm=0;
	GAM_ROOM();
	body[49][0]=8;
	body[49][1]=7;
	LED_DRAW(food[0],food[1]);
	TA0CTL=TASSEL_2+MC_2;
	for(mm=0;mm<length;mm++)LED_DRAW(body[mm][0],body[mm][1]);
}
void GAM_KEY(void){
	if(!(P1IN&BIT4)){
		if(key!=2)key=1;
		return;
	}
	if(!(P1IN&BIT5)){
		if(key!=1)key=2;
		return;
	}
	if(!(P1IN&BIT7)){
		if(key!=4)key=3;
		return;
	}
	if(!(P1IN&BIT6)){
		if(key!=3)key=4;
		return;
	}
	if(!(P1IN&BIT3)){
		while(!(P1IN&BIT3))LED_SHOW();
		KEY_DELAY();
		mode=!mode;
	}
}
void GAM_CYCLE(void){
	static int repeat=0;
	GAM_KEY();
	if((repeat++)==85){
		if(!mode)GAM_STEP();
		repeat=0;
	}
	LED_SHOW();
}
void SYS_WORK(void){
	SYS_START();
	if(!(P1IN&BIT3)){
		while(!(P1IN&BIT3));
		GAM_START();
		KEY_DELAY();
		while(1)GAM_CYCLE();
	}
	LED_START();
	while(1)LED_CYCLE();
}
#pragma vector=USCIAB0RX_VECTOR
__interrupt void SYS_UART(void){
	char get=UCA0RXBUF,j=0;
	switch(get){
		case 0x01:for(j=0;j<16;j++)tab[j]=0;count=0;break;
		case 0x02:for(j=0;j<16;j++)tab[j]=~tab[j];count=0;break;
		case 0x03:count=0;mode=~mode;break;
		case 0x04:WDTCTL=0;
		case 0x05:LPM4;
		case 0x06:count=0;pause=~pause;break;
		case 0x11:for(j=0;j<16;j++)tab0[0][j]=tab[j];count=0;break;
		case 0x12:for(j=0;j<16;j++)tab0[1][j]=tab[j];count=0;break;
		case 0x13:for(j=0;j<16;j++)tab0[2][j]=tab[j];count=0;break;
		case 0x14:for(j=0;j<16;j++)tab0[3][j]=tab[j];count=0;break;
		case 0x21:for(j=0;j<16;j++)tab[j]=tab0[0][j];count=0;break;
		case 0x22:for(j=0;j<16;j++)tab[j]=tab0[1][j];count=0;break;
		case 0x23:for(j=0;j<16;j++)tab[j]=tab0[2][j];count=0;break;
		case 0x24:for(j=0;j<16;j++)tab[j]=tab0[3][j];count=0;break;
		case 0x31:tap=1;break;
		case 0x32:tap=2;break;
		case 0x33:tap=3;break;
		case 0x34:tap=4;break;
		case 0x35:tap=5;
	}
}
